<?php

namespace Drupal\flashpoint_community_content\Access;

use Drupal\Core\Access\AccessResult;
use Drupal\Core\Entity\EntityInterface;
use Drupal\Core\Routing\RouteMatchInterface;
use Drupal\Core\Routing\Access\AccessInterface;
use Drupal\Core\Session\AccountInterface;
use Drupal\group\Entity\GroupContent;
use Symfony\Component\Routing\Route;


class FlashpointCommunityContentAccessLevelCheck implements AccessInterface {

  public function access(Route $route, RouteMatchInterface $route_match, AccountInterface $account) {
    // TODO: If we need this, develop access checking here.
    return AccessResult::allowed();
  }

  public static function getAccessLevels(array $array) {
    $ret = [];
    foreach ($array as $a) {
      $ret[] = $a['target_id'];
    }
    return $ret;
  }

  public static function checkAccessLevel(AccountInterface $account, EntityInterface $content) {
    // If the items doesn't have the access level field, then the user has access.
    if ($content->hasField('field_limit_to_these_access_leve')) {
      $content_al = $content->get('field_limit_to_these_access_leve')->getValue();
      if ($content_al) {
        $gc = GroupContent::loadByEntity($content);
        if ($gc) {
          $gc = array_shift($gc);
          $group = $gc->getGroup();
          $membership = \Drupal::service('group.membership_loader')->load($group, $account);
          if ($membership) {
            $membership = $membership->getGroupContent();
            if ($membership->hasField('field_access_levels')) {
              $membership_al = $membership->get('field_access_levels')->getValue();
              $mal = FlashpointCommunityContentAccessLevelCheck::getAccessLevels($membership_al);
              $cal = FlashpointCommunityContentAccessLevelCheck::getAccessLevels($content_al);
              if (empty(array_intersect($cal, $mal))) {
                return FALSE;
              }
            }
          }
        }
      }
    }
    /*
     * If we didn't make it all the way through the if
     * chain to the FALSE condition, then we met a condition
     * where data is missing or access levels are not applicable.
     *
     * We grant access in this case.
     */
    return TRUE;
  }

}